SystemOrganization addCategory: #Nautilus!

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 11:27'!
<= aRPackage 

	^ self name <= aRPackage name! !

!RPackage methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 12:40'!
orderedClasses

	| tmp |
	tmp := self definedClasses asArray sort: [:a :b | a name <= b name].
	tmp := tmp, (self extendedClasses asArray sort: [:a :b | a name <= b name]).
	^tmp
! !

StandardWindow subclass: #NautilusWindow
	instanceVariableNames: ''
	classVariableNames: 'Icon'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusWindow methodsFor: 'thumbnail' stamp: 'BenjaminVanRyseghem 3/18/2011 10:30'!
icon

	^ NautilusUI icon! !

!NautilusWindow methodsFor: 'open/close' stamp: 'BenjaminVanRyseghem 3/20/2011 06:15'!
initialExtent

	^ 700@500! !

Object subclass: #Nautilus
	instanceVariableNames: 'browsedEnvironment ui selectedPackage selectedCategory selectedMethod selectedClass selectedGroup showPackages showGroups showHierarchy showComment showInstance showCategories'
	classVariableNames: 'Groups RecentClasses'
	poolDictionaries: ''
	category: 'Nautilus'!

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses'!

!Nautilus commentStamp: 'BenjaminVanRyseghem 3/17/2011 16:20' prior: 0!
Nautilus new open !

Nautilus class
	instanceVariableNames: 'maxSize cachedLastClasses'!

!Nautilus class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/22/2011 11:37'!
browsedEnvironment: anEnvironment

	^ self new browsedEnvironment: anEnvironment! !

!Nautilus class methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/21/2011 15:39'!
buildGroupManager

	| holder |
	holder := GroupsHolder new.
	(holder 
		addADynamicGroupSilentlyNamed: 'Most Viewed Classes' 
		model: self 
		selector: #recentClassesElements) beReadOnly.
	(holder
		addADynamicGroupSilentlyNamed: 'Last Modified Classes' 
		model: self 
		selector: #lastModifiedClasses) beReadOnly;
		yourself
			! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:55'!
classEvent: anEvent

	self allInstances do: [:each | each classChanged: anEvent item ].
	anEvent isAdded
		ifTrue: [ self resetCachedLastClasses].
	anEvent isCommented
		ifTrue: [ self resetCachedLastClasses].
	anEvent isModified
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRecategorized
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRenamed
		ifTrue: [ self resetCachedLastClasses].
	anEvent isReorganized
		ifTrue: [ self resetCachedLastClasses].! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/18/2011 16:44'!
event: anEvent
	"Hook for SystemChangeNotifier"

	anEvent itemKind = SystemChangeNotifier classKind
		ifTrue:[ self classEvent: anEvent].
	anEvent itemKind = SystemChangeNotifier methodKind
		ifTrue:[ self methodEvent: anEvent].	
	! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:15'!
groupsManager

	^ Groups ifNil: [ Groups := self buildGroupManager]! !

!Nautilus class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/20/2011 01:27'!
icon 

	^ NautilusUI icon! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/18/2011 16:42'!
initialize

	super initialize.
	self startUp! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:26'!
lastModifiedClasses

	^ cachedLastClasses ifNil: [ cachedLastClasses := RecentMessageList uniqueInstance lastClasses: 10 ]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 15:45'!
maxSize

	^ maxSize ifNil: [ maxSize := 10]! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
maxSize: anInteger

	maxSize := anInteger.
	self recentClasses maxSize: anInteger.! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:48'!
methodEvent: anEvent

	self allInstances do: [:each | each methodChanged: anEvent item].
	anEvent isAdded
		ifTrue: [ self resetCachedLastClasses].
	anEvent isCommented
		ifTrue: [ self resetCachedLastClasses].
	anEvent isModified
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRecategorized
		ifTrue: [ self resetCachedLastClasses].
	anEvent isRenamed
		ifTrue: [ self resetCachedLastClasses].
	anEvent isReorganized
		ifTrue: [ self resetCachedLastClasses].! !

!Nautilus class methodsFor: 'menu' stamp: 'BenjaminVanRyseghem 3/20/2011 01:27'!
nautilusMenuOn: aBuilder 
	"I build a menu"
	<worldMenu>
	(aBuilder item: #Nautilus)
		action: [self new open];
		order: 0;
		help: 'Ready to browse the deeps of the system ?';
		icon: self icon! !

!Nautilus class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:13'!
recentClasses

	^ RecentClasses ifNil: [ RecentClasses := HistoryCollection maxSize: self maxSize ]! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:50'!
recentClassesElements

	^ self recentClasses mostViewedlements! !

!Nautilus class methodsFor: 'groups' stamp: 'BenjaminVanRyseghem 3/18/2011 16:44'!
resetCachedLastClasses

	^ cachedLastClasses := nil! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 06:44'!
startUp
	" self startUp "

	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:.! !

!Nautilus class methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 06:44'!
stopNotifications
	" self stopNotifications "
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allClasses

	^ self class environment allClassesAndTraits! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 10:00'!
allPackages

	^ RPackageOrganizer default packages sort: [:a :b | a name <= b name]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment

	^ browsedEnvironment ifNil: [ browsedEnvironment := BrowserEnvironment new ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 11:36'!
browsedEnvironment: anEnvironment

	browsedEnvironment := anEnvironment! !

!Nautilus methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:55'!
classChanged: aClass

	ui ifNotNil:[ ui classChanged: aClass ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:19'!
classes
	
	^ self browsedEnvironment classes! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 12:07'!
classesInTheSelectedPackage

	^ self selectedPackage
		ifNil: [{}]
		ifNotNil: [:package | 
			(package definedClasses asArray sort: [:a :b | a name <= b name]), (package extendedClasses asArray sort: [:a :b | a name <= b name])]! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 17:11'!
foundExtentionsIn: aClass

	| result |
	result :=  aClass extendingPackages.
	"self haltIf: [result isEmpty not]."
	^ result! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:49'!
groupsManager
	
	^ self class groupsManager! !

!Nautilus methodsFor: 'events' stamp: 'BenjaminVanRyseghem 3/20/2011 05:53'!
methodChanged: aCompiledMethod 

	ui ifNotNil:[ ui methodChanged: aCompiledMethod ]! !

!Nautilus methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/20/2011 05:49'!
open

	ui := (self uiClass on: self) open! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:19'!
packages

	^ self browsedEnvironment packages asArray sort! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/16/2011 09:59'!
packagesUsedByTheSelectedClass

	| result class |
	result := OrderedCollection new.
	class := self selectedClass.
	
	class ifNil: [^{}].
	result add: class package.
	result addAll: (self foundExtentionsIn: class).
	result := result intersection: self packages.
	^ result select:[:each | each notNil]! !

!Nautilus methodsFor: 'accessing' stamp: 'StephaneDucasse 3/17/2011 15:25'!
recentClasses

	^ self class recentClasses! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:50'!
resetGroupsManager

	GroupsManager := nil! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory

	^ selectedCategory! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedCategory: anObject

	selectedCategory := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedClass

	^ selectedClass! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 14:14'!
selectedClass: anObject

	selectedClass := anObject.
	anObject ifNotNil: [ self recentClasses add: anObject ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 13:55'!
selectedGroup

	^ selectedGroup! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:48'!
selectedGroup: anObject

	selectedGroup := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod

	^ selectedMethod! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedMethod: anObject

	selectedMethod := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/7/2011 14:57'!
selectedPackage

	^ selectedPackage! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/16/2011 14:09'!
selectedPackage: anObject

	selectedPackage := anObject! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showCategories

	^ showCategories ifNil: [ showCategories := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:52'!
showCategories: aBoolean

	showCategories := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showComment

	^ showComment ifNil: [ showComment := false ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:52'!
showComment: aBoolean

	showComment := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showGroups

	^ showGroups ifNil: [ showGroups := false ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showGroups: aBoolean

	showGroups := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showHierarchy

	^ showHierarchy ifNil: [ showHierarchy := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showHierarchy: aBoolean

	showHierarchy := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showInstance

	^ showInstance ifNil: [ showInstance := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showInstance: aBoolean

	showInstance := aBoolean! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ showPackages ifNil: [ showPackages := true ]! !

!Nautilus methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:53'!
showPackages: aBoolean

	showPackages := aBoolean! !

!Nautilus methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:59'!
uiClass

	^ NautilusUI! !

Object subclass: #NautilusUI
	instanceVariableNames: 'model window methodsTree selectedMethod selectedCategory hierarchyClass cachedHierarchy sourceTextArea firstColumn secondColumn commentPane'
	classVariableNames: 'Icon'
	poolDictionaries: ''
	category: 'Nautilus'!

!NautilusUI commentStamp: 'BenjaminVanRyseghem 3/17/2011 17:06' prior: 0!
I am browser in memory of Jules Vernes
I'm working on RPackage!

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:51'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #[0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 255 249 235 15 254 248 233 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 183 102 33 13 162 147 126 14 199 176 153 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 143 187 142 101 94 197 140 89 0 0 0 0 208 181 135 93 108 190 134 85 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 144 159 121 84 174 168 127 90 119 181 140 104 194 182 128 81 24 207 148 99 4 252 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 159 170 119 70 255 200 124 58 253 189 122 63 60 148 118 91 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 199 157 91 59 255 222 129 64 255 201 118 48 178 152 100 49 73 138 112 54 106 168 135 62 167 206 169 100 193 191 158 105 115 172 143 97 0 0 0 0 5 155 136 98 55 204 190 157 10 236 223 187 0 0 0 0 21 105 87 68 91 162 123 78 240 187 126 60 255 212 131 43 253 227 148 48 255 218 157 63 255 233 175 78 255 235 176 64 255 224 167 68 255 232 171 81 255 216 168 74 109 181 145 85 21 154 136 98 245 194 174 137 33 211 209 190 81 172 145 107 241 194 152 81 255 207 158 80 255 243 176 64 254 246 176 67 254 208 141 49 255 221 156 81 255 200 123 54 255 209 137 56 255 187 124 56 254 204 128 48 255 248 183 62 230 171 125 65 0 0 0 0 198 196 161 122 135 198 161 130 238 191 139 90 255 227 158 63 254 234 165 51 254 244 172 65 255 227 160 65 254 170 105 26 255 209 144 65 254 185 117 40 253 213 143 55 252 221 143 58 248 238 144 58 255 223 134 39 250 163 97 51 20 231 255 255 185 186 137 106 255 181 122 80 255 162 85 36 255 221 124 53 255 234 154 50 255 234 170 61 255 232 168 69 255 220 149 53 255 238 159 56 255 241 163 59 255 231 158 59 255 226 151 64 255 198 120 54 215 166 91 43 57 133 68 38 13 210 220 210 83 199 158 129 209 203 160 125 129 184 139 102 235 161 83 47 255 190 102 41 255 203 112 40 255 208 117 47 253 213 121 50 251 208 122 55 222 185 106 44 175 159 100 50 139 141 103 65 53 156 105 65 9 99 69 79 0 0 0 0 0 0 0 0 0 0 0 0 143 155 129 114 0 0 0 0 10 138 135 170 65 108 49 22 87 138 77 48 93 129 70 41 45 93 34 6 26 68 32 26 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 197 179 174 0 0 0 0 93 197 180 176 4 202 182 170 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 180 88 18 2 146 92 49 1 128 100 73 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0].
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:55'!
icon 

	^ Icon ifNil: [Icon := self buildIcon]! !

!NautilusUI class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
on: aNautilus

	^ self new model: aNautilus! !

!NautilusUI class methodsFor: 'icon' stamp: 'BenjaminVanRyseghem 3/17/2011 17:48'!
resetIcon

	Icon := nil! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/20/2011 07:54'!
addAll: aWindow
			
			
	| row |
	aWindow
		addMorph: (self buildFirstColumn: aWindow)
		frame: (0@0 corner: 0.33@0.5).		
				
	aWindow
		addMorph: (self buildSecondColumn: aWindow)
		frame: (0.33@0 corner: 0.66@0.5).

	aWindow 
		addMorph: (self buildMethodsTree)
		frame: (0.66@0 corner: 1@0.5).
	
	
	"
	row := AlignmentMorph newColumn
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutInset: 0;
		borderWidth: 1;
		layoutPolicy: ProportionalLayout new.
	window addMorph: row frame: (0@0.8 corner: 1@1).
	self buildClassCommentPane.
	window addMorph: commentPane fullFrame: commentPane defaultLayoutFrame."
	
aWindow
		addMorph: (self buildCodePane)
		frame: (0@0.5 corner: 1@1).! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/20/2011 23:55'!
addCategory

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^ self].
	labels := OrderedCollection new.
	reject := Set new.
	reject
		addAll: self selectedClass organization categories;
		add: ClassOrganizer nullCategory;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	self selectedClass allSuperclasses do: [:cls | | cats |
		cls = Object ifFalse: [
			cats := cls organization categories reject:
				 [:cat | reject includes: cat].
			cats isEmpty ifFalse: [
				lines add: labels size.
				labels addAll: cats asSortedCollection.
				reject addAll: cats ]]].
	
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: 'Add Category'.
	newName ifNil: [ ^self ].
	newName := newName asSymbol.

	self selectedClass organization
		addCategory: newName
		before: self selectedCategory.
	self selectedCategory: newName.
	methodsTree update.
	methodsTree setSelectedNodeItem: newName.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
addClassInAGroup

	(DialogGroupAdder new
		groups:	self groupsManager;
		elementToAdd: self selectedClass)
		open! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 15:45'!
addPackageAsGroup

	| package classes |
	package := self selectedPackage.
	classes := package definedClasses asArray sort: [:a :b | a name <= b name].
	classes := classes, package extendedClasses asArray sort: [:a :b | a name <= b name].

	^ self groupsManager	
			addADynamicGroupSilentlyNamed: package name 
			model: package 
			selector: #orderedClasses! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:44'!
addPackageAsGroupAndBrowse

	self addPackageAsGroup
		ifNotNil: [:group | 
			self selectedGroup: group.
			self showGroups: true]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index

	(aClass subclasses sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
addSubclassesOf: aClass in: result withIndex: index fromRestrictedCollection: aCollection

	| classes |
	
	classes := aClass subclasses intersection: aCollection.
	(classes sort: [:a :b| a name <= b name]) do: [:each |
		result add: each -> index.
		self addSubclassesOf: each in: result withIndex: index + 1 fromRestrictedCollection: aCollection]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
arrowKey: aCharacter from: aPluggableListMorph 
	aCharacter == $b
		ifTrue: [
			self selectedClass ifNotNil: [:class | class browse]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 23:28'!
asYetUnclassifiedString

	^ ClassOrganizer default! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 13:59'!
browseMessages
	
	self getSelectorAndSendQuery: #browseAllImplementorsOf: to: self systemNavigation with: {}! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 13:44'!
browseSendersOfMessages
	"Present a menu of the currently selected message, as well as all messages sent by it.  Open a message set browser of all senders of the selector chosen."

	self getSelectorAndSendQuery: #browseAllCallsOn: to: self systemNavigation with: {}! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 14:18'!
browseVersions
	"Create and schedule a Versions Browser, showing all versions of the 
	currently selected message. Answer the browser or nil."
	| selector class | 
	self showComment
		ifTrue: [ ClassCommentVersionsBrowser browseCommentOf: self selectedClass.
			^nil ].

	(selector := self selectedMethod selector)
		ifNil:[ self inform: 'Sorry, only actual methods have retrievable versions.'. ^nil ]
		ifNotNil: [
			class := self selectedClass.
			^VersionsBrowser
				browseVersionsOf: self selectedMethod
				class: self selectedClass
				meta: class isMeta
				category: self selectedCategory
				selector: selector]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 12:27'!
browsedEnvironment

	^ self model browsedEnvironment! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/20/2011 07:34'!
buildClassCommentPane
	"Construct the pane that shows the class comment.
	Respect the setting StandardFonts codeFont."

	commentPane := BrowserCommentTextMorph
				on: self
				text: #selectedClassComments
				accept: #classComment:notifying:
				readSelection: nil
				menu: #codePaneMenu:shifted:.
	commentPane font: StandardFonts codeFont.
	^ commentPane! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/20/2011 05:06'!
buildCodePane

	sourceTextArea := PluggableTextMorph
				on: self
				text: #sourceCode
				accept: #compileSource:notifying:
				readSelection: #contentsSelection
				menu: #codePaneMenu:shifted:.
	sourceTextArea askBeforeDiscardingEdits: true.
	^ sourceTextArea! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildCommentButton

	^ (PluggableButtonMorph
			on: self 
			getState: #commentButtonState
			action: #commentButtonAction
			label: #commentButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:54'!
buildFirstColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph.
		self buildList.
		aWindow newRow: {self buildToogleButton. self buildGroupsButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ firstColumn := GroupboxMorph new
			addContentMorph: self buildList;
			addContentMorph: (aWindow newRow: {self buildToogleButton. self buildGroupsButton});
			label: self labelText;
			hResizing: #spaceFill;
			vResizing: #spaceFill
			! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 12:44'!
buildGroupHierarchyFor: aGroup

	| result tmp index |
	result := OrderedCollection new.
	aGroup ifNil: [^ result ].
	((self rootsOfGroup: aGroup) asArray) do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: (aGroup elements)].
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildGroupsButton

	^ (PluggableButtonMorph
			on: self 
			getState: #groupsButtonState
			action: #groupsButtonAction
			label: #groupsButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildHierarchyFor: aClass

	| result tmp index |
	
	aClass ifNil: [^ {}].
	result := OrderedCollection new.
	tmp := aClass withAllSuperclasses reverse.
	1 to: tmp size do: [:i | result add: (tmp at: i) -> (i-1)].

	index := (tmp size -1).
	self addSubclassesOf: aClass in: result withIndex: index + 1.
	^ result! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildInstanceButton

	^ (PluggableButtonMorph
			on: self 
			getState: #instanceButtonState
			action: #instanceButtonAction
			label: #instanceButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 17:04'!
buildList

	| list |
	list := PluggableListMorph
				on: self
				list: #getList
				selected: #selected
				changeSelected: #selected:
				menu: #menu:shifted:.
	list doubleClickSelector: #doubleClick.
	list wrapSelector: #listWrapper:.
	list hResizing: #spaceFill.
	list vResizing: #spaceFill.
	^ list! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 17:03'!
buildList2

	| list2 |
	list2 := PluggableListMorph
				on: self
				list: #getList2
				selected: #selected2
				changeSelected: #selected2:
				menu: #menu2:shifted:.
	list2 wrapSelector: #listWrapper2:.
	list2 hResizing: #spaceFill.
	list2 vResizing: #spaceFill.
	^ list2! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/20/2011 23:17'!
buildMethodsTree

	methodsTree := SwitchableCategoriesTreeWithLabel
							on: self
							rootsSelector: #roots
							categoriesLabelSelector: #categoriesLabel
							elementsLabelSelector: #methodsLabel
							categoriesButtonLabelSelector: #categoriesButtonLabel
							elementsButtonLabelSelector: #methodsButtonLabel
							getSwitchSelector: #getSwitch
							setSwitchSelector: #setSwitch:
							getSelectedElementSelector: #selectedMethod
							setSelectedElementSelector: #selectedMethod:
							getSelectedCategorySelector: #selectedCategory
							setSelectedCategorySelector: #selectedCategory:
							setCategoryWrapperSelector: #categoryWrapper:
							setElementWrapperSelector: #methodWrapper:.
	methodsTree moveFromToIsCopySelector: #move:from:to:isCopy:.
	methodsTree
		categoriesMenuSelector: #categoriesMenu:shifted:;
		elementsMenuSelector: #elementsMenu:shifted:.
	^ methodsTree build! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildPackageHierarchyFor: aPackage

	| result tmp index |
	result := OrderedCollection new.
	((self rootsOf: aPackage) asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0).
		self addSubclassesOf: class in: result withIndex: 1 fromRestrictedCollection: aPackage definedClasses].
	(aPackage extendedClasses  asArray sort: [:a :b | a name <= b name ] )do:[:class |
		result add: (class -> 0)].
	^ result! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildPackagesClassesColumn: aWindow


	"container := PanelMorph new."
	"to fix in order to avoid the resize"
	
	"^ aWindow newColumn: {
			(aWindow newRow: {
				self buildFirstColumn: aWindow.
				self buildSecondColumn: aWindow})
				hResizing: #spaceFill; vResizing: #spaceFill.
			self buildToogleButton}"! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 06:49'!
buildRootsFromClass: aClass

	| result |
	result := Dictionary new.
	aClass ifNil: [^result].
	
	aClass methodDict values do: [:method || category |
		category := method category.
		(result at: category ifAbsent: [result at: category put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]).
		(result at: category) add: method].
	aClass organization categories do: [:each | 
		result 
			at: each 
			ifAbsent: [result at: each put: (SortedCollection sortBlock: [:a :b | a selector <= b selector])]
		].
	^ result ifEmpty: [result at: self noMethodsString put: OrderedCollection new;yourself]! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 16:57'!
buildSecondColumn: aWindow

	"^ (aWindow newColumn: {
		self buildLabelMorph2.
		self buildList2.
		aWindow newRow: {self buildInstanceButton. self buildCommentButton}}) 
		hResizing: #spaceFill; vResizing: #spaceFill"
		
	^ secondColumn := GroupboxMorph new
			addContentMorph: self buildList2;
			addContentMorph: (aWindow newRow: {self buildInstanceButton. self buildCommentButton});
			label: self labelText2;
			hResizing: #spaceFill;
			vResizing: #spaceFill! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildTabbedNameOf: anElement
			
	| tab result assoc |
	
	tab := '   '.
	result := ''.
	assoc := cachedHierarchy detect: [:each | each key == anElement ] ifNone: [''->0].
	1 to: assoc value do: [:i | result := tab, result].
	^ self selectedPackage 
		ifNil: [result, anElement name]
		ifNotNil: [:package | 
			(package extendedClasses includes: anElement)
				ifTrue: [ result , '*', anElement name ]
				ifFalse: [ result, anElement name ]]! !

!NautilusUI methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
buildToogleButton

	^ (PluggableButtonMorph
			on: self 
			getState: #toogleButtonState
			action: #toogleButtonAction
			label: #toogleButtonLabel) hResizing: #spaceFill; vResizing: #shrinkWrap! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoriesButtonLabel

	^ 'Switch to methods'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 18:46'!
categoriesLabel

	^ self showInstance
		ifTrue: ['Instance protocols:']
		ifFalse: ['Class protocols:']! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
categoriesMenu: aMenu shifted: b

	self commonMenu: aMenu shifted: b.
	aMenu addLine.
	
	aMenu
		add: 'New Category...' translated
		target: self
		selector: #addCategory.
		
	aMenu
		add: 'Rename...' translated
		target: self
		selector: #renameCategory.
	
	aMenu
		add: 'Categorize all uncategorized' translated
		target: self
		selector: #categorizeAllUncategorizedMethods.
	
	aMenu
		add: 'Remove empty categories' translated
		target: self
		selector: #removeEmptyCategories.
		
	aMenu
		add: 'Remove' translated
		target: self
		selector: #removeCategory.
		
	self categoriesRefactoringMenu: aMenu shifted: b.
		
	^ aMenu! !

!NautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
categoriesRefactoringMenu: aMenu shifted: b! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:14'!
categorizeAllUncategorizedMethods
	"Categorize methods by looking in parent classes for a method category."

	| organizer organizers |
	organizer := self selectedClass organization.
	organizers := self selectedClass withAllSuperclasses collect: [:ea | ea organization].
	(organizer listAtCategoryNamed: ClassOrganizer default) do: [:sel | | found |
		found := (organizers collect: [ :org | org categoryOfElement: sel])
			detect: [:ea | ea ~= ClassOrganizer default and: [ ea ~= nil]]
			ifNone: [].
		found ifNotNil: [organizer classify: sel under: found]].

	methodsTree update.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 19:12'!
categorizeMethod

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName item |
	self okToChange ifFalse: [^ self].
	self selectedMethod ifNil: [^ self].
	self selectedClass ifNil: [^self].
	labels := OrderedCollection new.
	labels
		addAll: self selectedClass organization categories;
		add: ClassOrganizer default.
	lines := OrderedCollection new.
	lines add: labels size -1.
	
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: ('Change Protocol (current: ', self selectedCategory,')').
	newName ifNil: [ ^self ].
	newName := newName asSymbol.
	item := self selectedMethod.
	
	item methodClass organization
				classify: item selector
				under: newName 
				suppressIfDefault: true.

	methodsTree update.
	methodsTree setSelectedNodeItem: item.! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
categoryWrapper: anItem

	^ anItem! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:58'!
changedLabels

	firstColumn label: self labelText.
	secondColumn label: self labelText2.! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/20/2011 06:03'!
classChanged: aClass

	(aClass package = self selectedPackage)
		ifTrue: [ self updateClassView ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
classLabel

	^'Class'! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 19:15'!
classesMenu: aMenu shifted: aBoolean 

	self selectedClass notNil
		ifTrue: [
			self showGroups
				ifTrue: [
					aMenu
						add: 'Remove from Group (X)' translated
						target: self
						selector: #removeClassFromGroup]
				ifFalse: [
					aMenu
						add: 'Add in Group (e)' translated
						target: self
						selector: #addClassInAGroup].
			aMenu addLine.
			
			aMenu
				add: 'Move to package ...' translated
				target: self
				selector: #moveInNewPackage.
				
			aMenu
				add: 'Remove class (x)' translated
				target: self
				selector: #removeClass ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 05:17'!
clearUserEditFlag
	
	sourceTextArea hasUnacceptedEdits: false.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 04:54'!
codePaneMenu: aMenu shifted: shifted 
	"Note that unless we override perform:orSendTo:, 
	PluggableTextController will respond to all menu items in a 
	text pane"
	| donorMenu |
	donorMenu := shifted
				ifTrue: [SmalltalkEditor shiftedYellowButtonMenu]
				ifFalse: [SmalltalkEditor yellowButtonMenu].
	^ aMenu addAllFrom: donorMenu! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonAction

	self toogleShowComment! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonLabel

	^ self commentLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentButtonState

	^ self showComment! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
commentLabel

	^ 'Show Comments'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 23:56'!
commonMenu: aMenu shifted: b

	^ aMenu! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/21/2011 15:49'!
compileSource: aText notifying: aController
	
	| source |
	source := aText asString.
	self selectedCategory
		ifNil: [
			(Compiler evaluate: source)
				ifNil: [^self]
				ifNotNil: [:class | 
					sourceTextArea update: #clearUserEdits.
					self selectedClass: class.
					self selectedPackage: class package.
					self showHierarchy
								ifTrue: [	self hierarchyClass: class ].
					self updatePackageView.
					self updateClassView ]]
		ifNotNil: [:category |
			self selectedClass
				ifNil: ["should never happened" self error]
				ifNotNil: [:class || cat |
					cat := category.
					category = self noMethodsString
						ifTrue: [ cat := self asYetUnclassifiedString ].
					(class compile: source classified: cat notifying: aController)
						ifNil: [^ self ]
						ifNotNil: [:selector || method |
							sourceTextArea update: #clearUserEdits.
							method := class methodDict at: selector.
							self selectedMethodSemiSilently: method.
							methodsTree update ]]].
		! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:54'!
contentsSelection

	self selectedClass isNil
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [^ (1 to: self defaultMethodSource size) ]]].
	^ (1 to: 0)! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
defaultClassDescriptor

	| string |
	string := 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: '''.
	^ self selectedPackage
		ifNil: [string, '''' ]
		ifNotNil: [:package | string, package name, '''' ]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:46'!
defaultMethodSource


	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:11'!
doItContext

	^ nil! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:12'!
doItReceiver

	^ self selectedClass theNonMetaClass! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 12:28'!
doubleClick

	self 
		ifGroups: [ self doubleClickOnGroup ]
		ifNot: [
			self ifPackages: [ self doubleClickOnPackage ] ifClasses: [ self doubleClickOnClass ]]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
doubleClickOnClass

	self toogleShowHierarchy! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 12:32'!
doubleClickOnGroup

	self selectedGroup 
		ifNil: [ ^self ]
		ifNotNil:[:group || newEnvironment | 
			newEnvironment := self browsedEnvironment forClasses: group elements.
			(self model class browsedEnvironment: newEnvironment) open	]! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/22/2011 12:33'!
doubleClickOnPackage

	self selectedPackage
		ifNil: [ ^ self ]
		ifNotNil:[:package || newEnvironment | 
			newEnvironment := self browsedEnvironment forPackages: {package}.
			(self model class browsedEnvironment: newEnvironment) open	]! !

!NautilusUI methodsFor: 'ugly compatibility' stamp: 'BenjaminVanRyseghem 3/20/2011 07:22'!
editSelection

	(self selectedClass notNil and: [self selectedCategory isNil])
		ifTrue: [^ #editClass].
	^ #other! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 19:15'!
elementsMenu: aMenu shifted: b

	self commonMenu: aMenu shifted: b.
	aMenu addLine.
	
	aMenu
		add: 'Senders of...(n)' translated
		target: self
		selector: #browseSendersOfMessages.
	
	aMenu 
		add: 'Implementors of... (m)' translated
		target: self
		selector: #browseMessages.
		
	aMenu
		add: 'Inheritance (i)' translated
		target: self
		selector: #methodHierarchy.
		
	aMenu
		add: 'Versions (v)' translated
		target: self
		selector: #browseVersions.	
			
	aMenu
		add: 'Categorize method (C)' translated
		target: self
		selector: #categorizeMethod.
			
	aMenu
		add: 'Remove method (x)' translated
		target: self
		selector: #removeMethod.
	
	self elementsRefactoringMenu: aMenu shifted: b.
	
	^ aMenu! !

!NautilusUI methodsFor: 'menus extensions' stamp: 'BenjaminVanRyseghem 3/21/2011 14:20'!
elementsRefactoringMenu: aMenu shifted: b! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
foundPackageOf: aClass

	aClass ifNil: [^ nil].
	^ aClass package! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassHierarchy

	self hierarchyClass
		ifNil: [^self getClassesList].

	^ cachedHierarchy collect: [:each | each key ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassHierarchy2

	self showPackages ifFalse: [self halt].
	^ self selectedPackage
		ifNil: [{}]
		ifNotNil:[:package |
			cachedHierarchy := self buildPackageHierarchyFor: package.
			cachedHierarchy collect: [:each | each key ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassesList

	^ self model classes! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getClassesList2

	^ self model packagesUsedByTheSelectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getGroupHierarchy

	^ self selectedGroup 
		ifNil: [^ {}]
		ifNotNil: [:group |
			cachedHierarchy := self buildGroupHierarchyFor: group.
			cachedHierarchy collect: [:assoc | assoc key] ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
getGroupsKeyList

	^ self groupsManager groups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 12:45'!
getGroupsValuesList

	^ (self groupsManager at: self selectedGroup ifAbsent: [{}])! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getList
	
	^
	self 
		ifGroups: [ self getGroupsKeyList ]
		ifNot: [
			self 
				ifPackages: [ self getPackagesList ] 
				ifClasses: [
					self selectedClass
						ifNil: [ 
							cachedHierarchy
								ifNil: [ self getClassesList ]
								ifNotNil: [:col | col collect: [:assoc | assoc key]]]
						ifNotNil: [:class | 
							self showHierarchy
								ifTrue: [ self getClassHierarchy ]
								ifFalse:[ {class} ]]]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getList2
	
	^ self 
		ifGroups: [
			self showHierarchy
				ifTrue: [ self getGroupHierarchy ]
				ifFalse: [ self getGroupsValuesList ]]
		ifNot: [
			 self 
				ifPackages: [
					self showHierarchy
						ifTrue: [ self getClassHierarchy2 ]
						ifFalse: [ self getPackagesList2 ]]
				ifClasses: [self getClassesList2 ]]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getPackagesList

	^ self model packages! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
getPackagesList2

	^ self model classesInTheSelectedPackage! !

!NautilusUI methodsFor: 'code holder behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 13:45'!
getSelectorAndSendQuery: querySelector to: queryPerformer with: queryArgs
	"Obtain a selector relevant to the current context, and then send the querySelector to the queryPerformer with the selector obtained and queryArgs as its arguments.  If no message is currently selected, then obtain a method name from a user type-in"

	| strm array |
	strm := (array := Array new: queryArgs size + 1) writeStream.
	strm nextPut: nil.
	strm nextPutAll: queryArgs.

	self selectedMethod ifNil: [ | selector |
		selector := UIManager default request: 'Type selector:' initialAnswer: 'flag:'.
		selector ifNil: [selector := String new].
		selector := selector copyWithout: Character space.
		^ selector isEmptyOrNil ifFalse: [
			(Symbol hasInterned: selector
				ifTrue: [ :aSymbol |
					array at: 1 put: aSymbol.
					queryPerformer perform: querySelector withArguments: array])
				ifFalse: [ self inform: 'no such selector']
		]
	].

	array at: 1 put: self selectedMethod selector.
	queryPerformer perform: querySelector withArguments: array! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
getSwitch 

	^ self model showCategories! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonAction

	self toogleShowGroups! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonLabel

	^ self groupsLabel! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsButtonState

	^ self showGroups! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
groupsLabel

	^ 'Show Groups'! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 14:52'!
groupsManager

	^ self model groupsManager! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
groupsMenu: aMenu shifted: aBoolean 

	(self selectedGroup isNil
			or: [self selectedGroup isReadOnly])
		ifFalse: [
			aMenu
				add: 'Rename (r)' translated
				target: self
				selector: #renameAGroup.
			aMenu
				add: 'Remove (x)' translated
				target: self
				selector: #removeAGroup]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass

	^ hierarchyClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
hierarchyClass: aClass

	hierarchyClass := aClass.
	cachedHierarchy := self buildHierarchyFor: aClass.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifGroups: aBlock ifNot: anotherBlock

	^self showGroups
			ifTrue: aBlock
			ifFalse: anotherBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
ifPackages: pBlock ifClasses: cBlock

	^ self showPackages
		ifTrue: pBlock
		ifFalse: cBlock! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
initialize

	super initialize.
	cachedHierarchy := OrderedCollection new.! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceButtonAction

	self toogleShowInstance! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 18:43'!
instanceButtonLabel

	^ self showInstance
		ifTrue: [ self classLabel ]
		ifFalse: [ self instanceLabel ]! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 18:45'!
instanceButtonState

	^ false! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
instanceLabel

	^'Instance'! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 01:07'!
labelText

	^ self showGroups
		ifTrue: [ 'Groups:']
		ifFalse: [self ifPackages: ['Packages:'] ifClasses: ['Classes:']]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
labelText2

	^ self ifPackages: ['Classes:'] ifClasses: ['Packages:']! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
listWrapper2: anElement

	^ self 
		ifPackages:	[
			"anElement is a Class"
			self showHierarchy
				ifTrue: [ self buildTabbedNameOf: anElement ]
				ifFalse: [
					(self selectedPackage extendedClasses includes: anElement)
						ifTrue: ['*', anElement name]
						ifFalse: [anElement name]]]
		ifClasses: [
			"anElement is a RPackage"
			(self selectedClass package == anElement)
				ifTrue: [anElement name]
				ifFalse: ['*', anElement name]]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/18/2011 14:47'!
listWrapper: anElement

	anElement = 0 ifTrue: [^''].
	^ self 
		ifGroups: [ anElement name ]
		ifNot: [ self 
				ifPackages: [ anElement name  ] 
				ifClasses: [ 
					self showHierarchy
						ifTrue: [ self buildTabbedNameOf: anElement ]
						ifFalse:[ anElement name ]]]! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
menu2: aMenu shifted: aBoolean 
	self
		ifPackages: [self classesMenu: aMenu shifted: aBoolean]
		ifClasses: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]].
	^ aMenu! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
menu: aMenu shifted: aBoolean 
	self
		ifPackages: [
			self showGroups
				ifTrue: [self groupsMenu: aMenu shifted: aBoolean]
				ifFalse: [self packagesMenu: aMenu shifted: aBoolean]]
		ifClasses: [self classesMenu: aMenu shifted: aBoolean].
	^ aMenu! !

!NautilusUI methodsFor: 'events handling' stamp: 'BenjaminVanRyseghem 3/20/2011 05:54'!
methodChanged: aCompiledMethod 

	(aCompiledMethod methodClass = self selectedClass)
		ifTrue: [ methodsTree update ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 14:13'!
methodHierarchy
	"Create and schedule a method browser on the hierarchy of implementors."

	self systemNavigation 
			methodHierarchyBrowserForClass: self selectedClass
			selector: self selectedMethod selector! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodWrapper: anItem

	^ anItem selector! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
methodsButtonLabel

	^ 'Switch to categories'! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 18:46'!
methodsLabel

	^ self showInstance
		ifTrue: ['Instance methods']
		ifFalse: ['Class methods']! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model

	^ model! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
model: anObject

	model := anObject! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/21/2011 15:09'!
move: item from: oldCategory to: newCategory isCopy: isCopy

	isCopy
		ifFalse: [
			item methodClass organization
				classify: item selector
				under: newCategory 
				suppressIfDefault: true ]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 19:22'!
moveInNewPackage

	"Present a choice of categories or prompt for a new category name and add it before the current selection, or at the end if no current selection"
	| labels reject lines oldIndex newName item |
	self okToChange ifFalse: [^ self].
	self selectedClass ifNil: [^self].
	labels := self model packages collect: [:each | each name].
	lines := {0}.
		
	newName := UIManager default chooseOrRequestFrom: labels lines: lines title: ('Change Package (current: ', self selectedPackage name,')').
	newName ifNil: [ ^self ].
	newName := newName asSymbol.

	item := RPackageOrganizer default packageNamed: newName.
	self selectedPackage removeClass: self selectedClass.
	item addClassDefinition: self selectedClass.

	self selectedPackage: item.
	self updatePackageView.
	self updateClassView.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/20/2011 23:28'!
noMethodsString

	^ ClassOrganizer nullCategory! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 05:31'!
okToChange

	self canDiscardEdits ifTrue: [^ true].
	self changed: #wantToChange.  "Solicit cancel from view"
	^ self canDiscardEdits
! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:43'!
open

	window := NautilusWindow new model: self.
	self addAll: window.
	window openInWorld.
	window title: self title! !

!NautilusUI methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 3/21/2011 15:11'!
packagesMenu: aMenu shifted: aBoolean 

	aMenu
		add: 'Find Class... (f)'
		target: self
		selector: #openFindAClass.

	aMenu addLine.

	aMenu
		add: 'Add as Group & Browse (g)' translated
		target: self
		selector: #addPackageAsGroupAndBrowse.

	aMenu
		add: 'Add as Group (G)' translated
		target: self
		selector: #addPackageAsGroup! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
removeAGroup

	self groupsManager removeAGroup: self selectedGroup.
	self selectedGroup: nil.
	self changed: #getList.
	self changed: #getList2! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:01'!
removeCategory

	| messageCategoryName |
	self selectedCategory ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	messageCategoryName := self selectedCategory.
	(self confirm: 'Are you sure you want to
remove this method category 
and all its methods?')
		ifTrue: 
			[self selectedClass removeCategory: messageCategoryName.
			self selectedCategory: nil.
			methodsTree update]! !

!NautilusUI methodsFor: 'code holder behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 15:53'!
removeClass
	"Remove the selected class from the system, at interactive user request.  Make certain the user really wants to do this, since it is not reversible.  Answer true if removal actually happened."

	| message  className classToRemove result |
	self okToChange ifFalse: [^ false].
	classToRemove := self selectedClass ifNil: [Beeper beep. ^ false].
	classToRemove := classToRemove theNonMetaClass.
	className := classToRemove name.
	message := 'Are you certain that you
want to REMOVE the class ', className, '
from the system?'.
	(result := self confirm: message)
		ifTrue: 
			[classToRemove subclasses size > 0
				ifTrue: [(self confirm: 'class has subclasses: ' , message)
					ifFalse: [^ false]].
			classToRemove removeFromSystem.
			self selectedClass: nil.
			self updateClassView].
	^ result! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 14:53'!
removeClassFromGroup

	self groupsManager remove: self selectedClass from: self selectedGroup.
	self changed: #getList2.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:07'!
removeEmptyCategories

	self okToChange ifFalse: [^ self].
	(self roots at: self selectedCategory) 
		ifEmpty: [ self selectedCategory: nil ].
	self selectedClass organization removeEmptyCategories.
	methodsTree update.! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:56'!
removeMethod
	"If a message is selected, create a Confirmer so the user can verify that  
	the currently selected message should be removed from the system. If 
	so, remove it. "
	| messageName confirmation |
	self selectedMethod ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	messageName := self selectedMethod selector.
	confirmation := self systemNavigation   confirmRemovalOf: messageName on: self selectedClass.
	confirmation == 3
		ifTrue: [^ self].
	(self selectedClass includesLocalSelector: messageName)
		ifTrue: [self selectedClass removeSelector: messageName]
		ifFalse: [self removeNonLocalSelector: messageName].
	self selectedMethod: nil.
	methodsTree update.
	methodsTree setSelectedNodeItem: self selectedCategory.
	"In case organization not cached"
	confirmation == 2
		ifTrue: [self systemNavigation browseAllCallsOn: messageName]! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:54'!
removeNonLocalSelector: aSymbol
	| traits isAlias |
	traits := self selectedClass traitsProvidingSelector: aSymbol.
	isAlias := self selectedClass isLocalAliasSelector: aSymbol.
	isAlias
		ifTrue: [
			[traits size = 1] assert.
			self selectedClass removeAlias: aSymbol of: traits first]
		ifFalse: [
			traits do: [:each |
				self selectedClass addExclusionOf: aSymbol to: each ]]
	! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 15:03'!
renameAGroup

	| newName |
	self groupsManager renameAGroup: self selectedGroup.
	self changed: #getList.
	self changed: #getLIst2! !

!NautilusUI methodsFor: 'menus behavior' stamp: 'BenjaminVanRyseghem 3/21/2011 00:28'!
renameCategory
	"Prompt for a new category name and add it before the
	current selection, or at the end if no current selection"
	
	| oldIndex oldName newName |
	self selectedClass ifNil: [^ self].
	self okToChange ifFalse: [^ self].
	self selectedCategory ifNil: [^ self].
	oldName := self selectedCategory.
	newName := UIManager default
		request: 'Please type new category name'
		initialAnswer: oldName.
	newName isEmptyOrNil
		ifTrue: [^ self]
		ifFalse: [newName := newName asSymbol].
	newName = oldName ifTrue: [^ self].
	self selectedClass organization
		renameCategory: oldName
		toBe: newName.
	self selectedCategory: newName.
	methodsTree update.
	methodsTree setSelectedNodeItem: newName.! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/19/2011 23:50'!
roots
		
	^ self buildRootsFromClass: self selectedClass! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
rootsOf: aPackage

	^ aPackage definedClasses select: [:each |
		(aPackage definedClasses includes: each superclass)  not]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/22/2011 12:44'!
rootsOfGroup: aGroup

	| classes |
	classes := aGroup elements.
	^ classes select: [:each |
		(classes includes: each superclass)  not]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selected

	| item |
	item :=  self 
				ifGroups: [ self selectedGroup ]
				ifNot: [ self ifPackages: [ self selectedPackage ] ifClasses: [ self selectedClass ]].
				
	^self getList indexOf: item.
	"^ selected ifNil: [selected := 0]"! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 16:20'!
selected2

	| item |
	item :=  self ifPackages: [ self selectedClass ] ifClasses: [ self selectedPackage ].
	self showInstance ifFalse: [ item ifNotNil: [item := item soleInstance]].
	^self getList2 indexOf: item.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/18/2011 16:22'!
selected2: anInteger

	| selection |
	selection := self getList2 at: anInteger ifAbsent: [nil].
	self 
		ifPackages: [ 
			self showInstance ifFalse: [selection ifNotNil: [selection := selection class]].
			self selectedClass: selection ] 
		ifClasses: [	self selectedPackage: selection ].
	self changed: #selected2.
	anInteger = 0 ifTrue: [^self].
	self changed: #getList.
	self changed: #getList2.
	self changed: #selected.
	! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selected: anInteger

	| selection |
	selection := self getList at: anInteger ifAbsent: [nil].
	self 
		ifGroups: [ self selectedGroup: selection ]
		ifNot: [ self ifPackages: [ self selectedPackage: selection] ifClasses: [ self selectedClass: selection] ].

	self changed: #selected.
	self changed: #getList2! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedCategory

	^ selectedCategory! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 07:17'!
selectedCategory: anObject

	self okToChange
		ifTrue: [
			selectedCategory := anObject.
			self selectedMethod: nil.
			self changed: #editSelection.
			^ true].
	^ false! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/19/2011 23:49'!
selectedCategorySilently: anObject

	selectedCategory := anObject.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClass

	^ self model selectedClass! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/19/2011 23:28'!
selectedClass: aClass 

	self model selectedClass: aClass.
	self showGroups ifTrue: [self selectedPackage: (self foundPackageOf: aClass) ].
	self showPackages
		ifFalse: [ 
			self selectedPackage: (self foundPackageOf: aClass).
			self changed: #getList2].
	self selectedCategory: nil.
	self update.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 07:19'!
selectedClassComments

	^ self selectedClass
		ifNil: ['']
		ifNotNil: [:class| class comment]! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedClassDescription

	^ self selectedClass definition! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedGroup
	
	^ self model selectedGroup! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/21/2011 16:07'!
selectedGroup: anObject

	self model selectedGroup: anObject.
	self selectedClass: nil.! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 05:17'!
selectedMethod
	^ selectedMethod ! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 05:34'!
selectedMethod: aCompiledMethod 

	self okToChange
		ifTrue: [
			self selectedMethodSemiSilently: aCompiledMethod. 
			self changed: #sourceCode.
			^ true].
	^false ! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodComments

	^ self selectedMethod comment! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 05:32'!
selectedMethodSemiSilently: aCompiledMethod 

	self okToChange
		ifTrue: [
			self selectedMethodSilently: aCompiledMethod.
			aCompiledMethod ifNotNil: [ self selectedCategorySilently: aCompiledMethod category ]]! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/20/2011 05:20'!
selectedMethodSilently: aCompiledMethod 

	selectedMethod := aCompiledMethod.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedMethodSource

	^ self selectedMethod getSource! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedPackage

	^ self model selectedPackage! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
selectedPackage: aPackage

	self model selectedPackage: aPackage.
	(self showPackages and: [self selectedClass notNil and: [self selectedClass package ~= aPackage]])
		ifTrue: [ self selectedClass: nil ].
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'widget needed methods' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
setSwitch: aBoolean

	^ self model showCategories: aBoolean! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showComment

	^ self model showComment! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:54'!
showComment: aBoolean

	self model showComment: aBoolean.
	self changed: #sourceCode! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showGroups

	^ self model showGroups! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 13:04'!
showGroups: aBoolean

	self showPackages 
		ifFalse: [ self showPackages: true ].
	self model showGroups: aBoolean.
	self changedLabels.
	self changed: #getList.
	self changed: #getList2.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showHierarchy

	^ self model showHierarchy! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
showHierarchy: aBoolean

	self model showHierarchy: aBoolean.
	aBoolean 
		ifTrue: [self hierarchyClass: self selectedClass]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:56'!
showInstance

	^ self model showInstance! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:57'!
showInstance: aBoolean

	self model showInstance: aBoolean.
	self selectedClass 
		ifNotNil: [:class | 
			aBoolean 
				ifTrue: [self selectedClass: class soleInstance]
				ifFalse: [self selectedClass: class class]].
	methodsTree update.
	self changed: #instanceButtonLabel! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:55'!
showPackages

	^ self model showPackages! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2011 12:58'!
showPackages: aBoolean

	self model showPackages: aBoolean.
	aBoolean ifFalse: [
		self hierarchyClass: self selectedClass].
	self showGroups
		ifTrue: [self showGroups: false].
	self changed: #getList.
	self changed: #getList2.
	self changed: #toogleButtonState.
	self changedLabels.! !

!NautilusUI methodsFor: 'source code area' stamp: 'BenjaminVanRyseghem 3/20/2011 00:40'!
sourceCode

	^self selectedClass isNil
		ifTrue: [self defaultClassDescriptor]
		ifFalse:[	
			self selectedMethod isNil
				ifTrue: [
					self selectedCategory notNil
						ifTrue: [self defaultMethodSource]
						ifFalse: [
							self showComment
								ifTrue: [self selectedClassComments]
								ifFalse: [self selectedClassDescription]]]
				ifFalse: [
					self showComment
						ifTrue: [self selectedMethodComments]
						ifFalse: [self selectedMethodSource]]].
		! !

!NautilusUI methodsFor: 'displaying' stamp: 'BenjaminVanRyseghem 3/17/2011 17:41'!
taskbarIcon

	^ self class icon! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
title

	^'Nautilus'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 17:00'!
toogleButtonAction

	self selectedClass ifNil: [^self].
	self toogleShowPackages! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleButtonLabel

	^ 'Hierarchy'! !

!NautilusUI methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 3/18/2011 16:47'!
toogleButtonState

	^ self showPackages not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowComment

	self showComment: self showComment not! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowGroups

	self showGroups: self showGroups not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowHierarchy

	self showHierarchy: self showHierarchy not.
	self changed: #getList.
	self changed: #getList2.
! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowInstance

	self showInstance: self showInstance not.! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
toogleShowPackages

	self showPackages: self showPackages not.! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
update

	methodsTree ifNotNil: [:tree | tree update]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/19/2011 23:45'!
updateClassView

	self	
		ifPackages:  [self changed: #getList2 ]
		ifClasses: [ self changed: #getList ]! !

!NautilusUI methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/19/2011 23:45'!
updatePackageView

	self	
		ifPackages: [ self changed: #getList ]
		ifClasses: [	self changed: #getList2 ]! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window

	^ window! !

!NautilusUI methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/17/2011 16:50'!
window: anObject

	window := anObject! !

!BrowserEnvironment methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/22/2011 11:30'!
packages

	^ (self classes collect: [:each | each package ]) asSet! !

!RecentMessageList methodsFor: '*Nautilus' stamp: 'BenjaminVanRyseghem 3/18/2011 16:41'!
lastClasses: anInteger

	"I return the last anInteger classes modified"
	| result tempList |
	result := OrderedCollection new.
	tempList := self methodReferenceList copy sort: [:a :b | a timeStamp >= b timeStamp].
	
	tempList do: [:method || class |
		result size = anInteger ifTrue: [^result].
		class := method methodClass.
		(result includes: class) ifFalse: [result add: class]].
	^ result! !

!Trait methodsFor: '*Nautilus' stamp: 'BenjaminVanRysghem 3/17/2011 16:32'!
superclass
	" use to be polymorphic with classes "

	^ nil! !
Nautilus initialize!
